#include "fifo.h"

void fifo_init(struct fifo_vars *fifo, char *buffer, unsigned int len){
	
	fifo->fbuf = buffer;
	fifo->indexmax = len - 1;
	
	fifo_clear(fifo);
}

void fifo_clear(struct fifo_vars *fifo) {

	fifo->head  = 0;
	fifo->tail  = 0;
}

void fifo_put(struct fifo_vars *fifo, char c){
	
	unsigned int temp = 0;
	
	// Pointer++ mit Wraparound
	if (fifo->head < fifo->indexmax){
		temp = fifo->head + 1;
	}
	
	//FIFO voll
	if (temp == fifo->tail){
		return;
	}
	
	fifo->fbuf[temp] = c;
	fifo->head = temp;
}

void fifo_put_block(struct fifo_vars *fifo, char c){
	
	unsigned int temp = 0;
	
	// Pointer++ mit Wraparound
	if (fifo->head < fifo->indexmax){
		temp = fifo->head + 1;
	}
	
	// FIFO voll
	while (temp == fifo->tail){;}
	
	fifo->fbuf[temp] = c;
	fifo->head = temp;
}

char fifo_get(struct fifo_vars *fifo){

	unsigned int temp = 0;

	// FIFO leer
	if (fifo->head == fifo->tail){
		return 0;
	}
	
	// Pointer++ mit Wraparound
	if (fifo->tail < fifo->indexmax){
		temp = fifo->tail + 1;
	}
	
	char c = fifo->fbuf[temp];
	fifo->tail = temp;
	return c;
}

char fifo_get_block(struct fifo_vars *fifo){

	unsigned int temp = 0;

	// FIFO leer
	while (fifo->head == fifo->tail){;}
	
	// Pointer++ mit Wraparound
	if (fifo->tail < fifo->indexmax){
		temp = fifo->tail + 1;
	}
	
	char c = fifo->fbuf[temp];
	fifo->tail = temp;
	return c;
}

unsigned int fifo_empty(struct fifo_vars *fifo){
	return fifo->head == fifo->tail;
}
