#include "rcc.h"
#include "rcc_regdefs.h"

#define RCC_BASE_INT 0x40023800
static volatile struct rcc * const rcc = (struct rcc *)RCC_BASE_INT;

// ein enum clk_periph definiert mit Bitgefrickel dem passenden Registeroffset und das passende Bit
#define ENUM_BITPOS_MSK 0b00011111
#define ENUM_BITPOS_POS 0
#define ENUM_REGPOS_MSK 0b11000000
#define ENUM_REGPOS_POS 6
#define ENUM_BUSPOS_MSK 0b00100000
#define ENUM_BUSPOS_POS 5

void rcc_enable_clock(enum clk_periph toenable){

	unsigned int bitnr =  toenable & ENUM_BITPOS_MSK;
	unsigned int regnr = (toenable & ENUM_REGPOS_MSK) >> ENUM_REGPOS_POS;
	regnr -= 1; //im enum steht AHB1, aber das ist index 0
	
	// passende basis raussuchen (AHB/APB)
	volatile unsigned int *reg = &(rcc->APB1ENR);
	if (toenable & ENUM_BUSPOS_MSK){
		// war wohl doch AHB
		reg = &(rcc->AHB1ENR);
	}
	
	reg[regnr] |= (1 << bitnr);
}

