#ifndef RCC_REGDEFS_H
#define RCC_REGDEFS_H

struct rcc {
	unsigned int CR;
	unsigned int PLLCFGR;
	unsigned int CFGR;
	unsigned int CIR;
	unsigned int AHB1RSTR;
	unsigned int AHB2RSTR;
	unsigned int AHB3RSTR;
	unsigned int reserved0;
	unsigned int APB1RSTR;
	unsigned int APB2RSTR;
	unsigned int reserved1[2];
	unsigned int AHB1ENR;
	unsigned int AHB2ENR;
	unsigned int AHB3ENR;
	unsigned int reserved2;
	unsigned int APB1ENR;
	unsigned int APB2ENR;
	unsigned int reserved3[2];
	unsigned int AHB1LPENR;
	unsigned int AHB2LPENR;
	unsigned int AHB3LPENR;
	unsigned int reserved4;
	unsigned int APB1LPENR;
	unsigned int APB2LPENR;
	unsigned int reserved5[2];
	unsigned int BDCR;
	unsigned int CSR;
	unsigned int reserved6[2];
	unsigned int SSCGR;
	unsigned int PLLI2SCFGR;
};

enum reg_cr {
	CR_PLLI2SRDY 	= 1 << 27,
	CR_PLLI2SON 	= 1 << 26,
	CR_PLLRDY 		= 1 << 25,
	CR_PLLON  		= 1 << 24,
	CR_HSERDY 		= 1 << 17,
	CR_HSEON  		= 1 << 16,
};

enum reg_pllcfgr {
	PLLCFGR_PLLQ_SHIFT 	 = 24,
	PLLCFGR_PLLSRC_SHIFT = 22,
	PLLCFGR_PLLP_SHIFT 	 = 16,
	PLLCFGR_PLLN_SHIFT 	 = 6,
	PLLCFGR_PLLM_SHIFT 	 = 0,
};

enum reg_cfgr {
	CFGR_MCO2_SHIFT 	= 30,
	CFGR_MCO2PRE_SHIFT 	= 27,
	CFGR_MCO1PRE_SHIFT 	= 24,
	CFGR_I2SSRC 		= 1 << 23,		//0: PLLI2S clock used as I2S clock source; 1: External clock
	CFGR_MCO1_SHIFT 	= 21,
	CFGR_PPRE2_SHIFT 	= 13,
	CFGR_PPRE1_SHIFT 	= 10,
	CFGR_HPRE_SHIFT  	= 4,
};

enum reg_PLLI2SCFGR {
	PLLI2SCFGR_PLLI2SR_SHIFT = 28,
	PLLI2SCFGR_PLLI2SN_SHIFT = 6,
};

#endif//RCC_REGDEFS_H