#ifndef USART_REGDEFS_H
#define USART_REGDEFS_H

struct usart {
	unsigned int SR;
	unsigned int DR;
	unsigned int BRR;
	unsigned int CR1;
	unsigned int CR2;
	unsigned int CR3;
	unsigned int GTPR;
};

enum reg_SR {
	SR_CTS  = 1 << 9,
	SR_LBD  = 1 << 8,
	SR_TXE  = 1 << 7,
	SR_TC   = 1 << 6,
	SR_RXNE = 1 << 5,
	SR_IDLE = 1 << 4,
	SR_ORE  = 1 << 3,
	SR_NF   = 1 << 2,
	SR_FE   = 1 << 1,
	SR_PE   = 1 << 0,
};

enum reg_CR1 {
	CR1_OVER8 	= 1 << 15,
	CR1_UE 		= 1 << 13,
	CR1_M 		= 1 << 12,
	CR1_WAKE 	= 1 << 11,
	CR1_PCE 	= 1 << 10,
	CR1_PS 		= 1 << 9,
	CR1_PEIE 	= 1 << 8,
	CR1_TXEIE 	= 1 << 7,
	CR1_TCIE 	= 1 << 6,
	CR1_RXNEIE 	= 1 << 5,
	CR1_IDLEIE 	= 1 << 4,
	CR1_TE	 	= 1 << 3,
	CR1_RE 		= 1 << 2,
	CR1_RWU 	= 1 << 1,
	CR1_SBK 	= 1 << 0,
};

enum reg_CR2 {
	CR2_LINEN 	= 1 << 14,
	CR2_STOP 	= 1 << 12,
	CR2_CLKEN 	= 1 << 11,
	CR2_CPOL 	= 1 << 10,
	CR2_CPHA 	= 1 << 9,
	CR2_LBCL 	= 1 << 8,
	CR2_LBDIE 	= 1 << 6,
	CR2_LBDL 	= 1 << 5,
	CR2_ADD 	= 1 << 0,
};

enum reg_CR3 {
	CR3_ONEBIT 	= 1 << 11,	// One sample bit method enable
	CR3_CTSIE 	= 1 << 10,	// CTS interrupt enable
	CR3_CTSE 	= 1 << 9,	// CTS enable
	CR3_RTSE 	= 1 << 8,	// RTS enable
	CR3_DMAT 	= 1 << 7,	// DMA enable transmitter
	CR3_DMAR 	= 1 << 6,	// DMA enable receiver
	CR3_SCEN 	= 1 << 5,	// Smartcard mode enable
	CR3_NACK 	= 1 << 4,	// Smartcard NACK enable
	CR3_HDSEL 	= 1 << 3,	// Half-duplex selection
	CR3_IRLP 	= 1 << 2,	// IrDA low-power
	CR3_IREN 	= 1 << 1,	// IrDA mode enable
	CR3_EIE 	= 1 << 0,	// Error interrupt enable
};

#endif//USART_REGDEFS_H