/* 
 * This file is part of the ARM Cortex-M Fault distribution.
 * Copyright (c) 2018 Martin Wende.
 * 
 * This program is free software: you can redistribute it and/or modify  
 * it under the terms of the GNU General Public License as published by  
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

.thumb
.syntax unified

.global hardfault_tramp
hardfault_tramp:
	sub r0, sp, #(8*4) 			//Stackpointer nach r0, denn writebackregister darf nicht in Liste sein
								//Mit Abzug von 8*4 wegen Exception HW Stackpush
	stmfd sp!, {r0}				//STackpointer auf Stack fr Regdump
	stmfd sp!, {r4 - r11}
	mov r0, sp
	bl hardfault_handler
	
.global mpufault_tramp
mpufault_tramp:
	sub r0, sp, #(8*4) 			//Stackpointer nach r0, denn writebackregister darf nicht in Liste sein
								//Mit Abzug von 8*4 wegen Exception HW Stackpush
	stmfd sp!, {r0}				//STackpointer auf Stack fr Regdump
	stmfd sp!, {r4 - r11}
	mov r0, sp
	bl mpufault_handler
	
.global busfault_tramp
busfault_tramp:
	sub r0, sp, #(8*4) 			//Stackpointer nach r0, denn writebackregister darf nicht in Liste sein
								//Mit Abzug von 8*4 wegen Exception HW Stackpush
	stmfd sp!, {r0}				//STackpointer auf Stack fr Regdump
	stmfd sp!, {r4 - r11}
	mov r0, sp
	bl busfault_handler
	
.global usagefault_tramp
usagefault_tramp:
	sub r0, sp, #(8*4) 			//Stackpointer nach r0, denn writebackregister darf nicht in Liste sein
								//Mit Abzug von 8*4 wegen Exception HW Stackpush
	stmfd sp!, {r0}				//STackpointer auf Stack fr Regdump
	stmfd sp!, {r4 - r11}
	mov r0, sp
	bl usagefault_handler
