/* 
 * This file is part of the ARM Cortex-M Fault distribution.
 * Copyright (c) 2018 Martin Wende.
 * 
 * This program is free software: you can redistribute it and/or modify  
 * it under the terms of the GNU General Public License as published by  
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

.thumb
.syntax unified

.section .text.vectors
_vectors:	
	.long	0x2001C000			//Stack ans RAM1 Ende
	.long	_startup+1			//Reset Handler
	.long	nmihandler+1		//NMI Handler
	.long	hardfault_tramp+1	//Hard Fault Handler
	.long	mpufault_tramp+1	//MPU Fault Handler
	.long	busfault_tramp+1	//Bus Fault Handler
	.long	usagefault_tramp+1	//Usage Fault Handler
	.long	0					//Reserved
	.long	0					//Reserved
	.long	0					//Reserved
	.long	0					//Reserved
	.long	svchandler			//SVCall Handler
	.long	dbgmhandler			//Debug Monitor Handler
	.long	0					//Reserved
	.long	pendsvhandler		//endSV Handler
	.long	systickhandler		//SysTick Handler
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0 		//DMA1_Stream0
	.long	0 		//DMA1_Stream1
	.long	0 		//DMA1_Stream2
	.long	0 		//DMA1_Stream3
	.long	0 		//DMA1_Stream4
	.long	0 		//DMA1_Stream5
	.long	0 		//DMA1_Stream6
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0 //SPI1
	.long	0 //SPI2
	.long	usart1_irq+1
	.long	usart2_irq+1
	.long	usart3_irq+1
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0  //DMA1_Stream7
	.long	0
	.long	0
	.long	0
	.long	0 //SPI3
	.long	usart4_irq+1
	.long	usart5_irq+1
	.long	0
	.long	0
	.long	0 //DMA2_Stream0
	.long	0 //DMA2_Stream1
	.long	0 //DMA2_Stream2
	.long	0 //DMA2_Stream3
	.long	0 //DMA2_Stream4
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0 //DMA2_Stream5
	.long	0 //DMA2_Stream6
	.long	0 //DMA2_Stream7
	.long	usart6_irq+1
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0

	
.section .text
.global _startup
_startup:
	// .data Section kopieren
	ldr r0, =_data_start
	ldr r1, =_rom_data_start
	ldr r2, =_data_size
	bl memcpy
	
	//.bss Section nullen
	ldr r0, =_bss_start
	mov r1, #0
	ldr r2, =_bss_size
	bl memset
	
	// .dma_data Section kopieren
	ldr r0, =_data2_start
	ldr r1, =_rom_data2_start
	ldr r2, =_data2_size
	bl memcpy
	
	//.dma_bss Section nullen
	ldr r0, =_bss2_start
	mov r1, #0
	ldr r2, =_bss2_size
	bl memset
	
	// Endlich ab ins Hauptprogramm
	b main
	
nmihandler:
	b nmihandler
	
svchandler:
	b svchandler
	
dbgmhandler:
	b dbgmhandler
	
pendsvhandler:
	b pendsvhandler
	
systickhandler :
	b systickhandler 
	
.global divme
divme:
	sdiv	r0, r0, r1
	bx lr
	
.global udfme
udfme:
	ldr r0, =0x100
	ldr r1, =0x200
	ldr r2, =0x300
	ldr r3, =0x400
	ldr r4, =0x500
	ldr r5, =0x600
	ldr r6, =0x700
	ldr r7, =0x800
	ldr r8, =0x900
	ldr r9, =0x1000
	ldr r10, =0x1100
	ldr r11, =0x1200
	ldr r12, =0x1300
	udf